
/**
 * Zone Manager
 *
 * @package zonemanager
 * @version 2.0
 * @author Bonus Themes
 * @copyright Bonus Themes 2008
 * @license GNU/GPL
 * @link http://www.bonusthemes.com/goto/zonemanager
 */

function ZmMenu(host_id)
{
	this.wdg = document.getElementById(host_id);
	this.control = null;
	this.timer = 0;

	this.zone_idx = -1;
	this.pos_name = null;
}

ZmMenu.prototype.h_mouseover = function (e)
{
	if (this.timer > 0) {
		clearTimeout(this.timer);
		this.timer = 0;
	}
}

ZmMenu.prototype.h_mouseout = function (e)
{
	if (this.timer > 0)
		clearTimeout(this.timer);

	this.timer = setTimeout('document.zm_menu.close()', 500);
}

ZmMenu.prototype.open = function (sender)
{
	this.control = sender;

	var type = this.control.getAttribute('type');
	document.getElementById('zm_menu_zone').style.display = type == 'zone' ? 'block' : 'none';
	document.getElementById('zm_menu_main_body').style.display = type == 'main_body' ? 'block' : 'none';
	document.getElementById('zm_menu_zone_position').style.display = type == 'zone_position' ? 'block' : 'none';
	document.getElementById('zm_menu_reg_position').style.display = type == 'reg_position' ? 'block' : 'none';

	this.zone_idx = type == 'reg_position' ? -1 : parseInt(this.control.getAttribute('zone_idx'));

	this.pos_name = this.control.getAttribute('pos_name');

	var x = 0, y = this.control.offsetHeight, obj = this.control;
	while (obj) {
		x += obj.offsetLeft;
		y += obj.offsetTop;
		obj = obj.offsetParent;
	}
	this.wdg.style.left = x + 'px';
	this.wdg.style.top = y + 'px';
	this.wdg.style.display = 'block';

	this.control.onmouseover = function (e) { document.zm_menu.h_mouseover(e); }
	this.wdg.onmouseover = function (e) { document.zm_menu.h_mouseover(e); }
	this.control.onmouseout = function (e) { document.zm_menu.h_mouseout(e); }
	this.wdg.onmouseout = function (e) { document.zm_menu.h_mouseout(e); }
}

ZmMenu.prototype.close = function ()
{
	if (this.timer > 0) {
		clearTimeout(this.timer);
		this.timer = 0;
	}

	if (this.control != null) {
		this.control.onmouseover = function () { }
		this.control.onmouseout = function () { }
	}

	this.control = null;
	this.wdg.style.display = 'none';
}

ZmMenu.prototype.h_click = function (sender)
{
	if (sender == this.control) {
		// toggle open/close
		if (this.control)
			this.close();
		else
			this.open(sender);
	}
	else {
		// close previous one, open new one
		if (this.control)
			this.close();

		this.open(sender);
	}
}
