<?php

/**
 * Zone Manager
 *
 * @package zonemanager
 * @version 2.0
 * @author Bonus Themes
 * @copyright Bonus Themes 2008
 * @license GNU/GPL
 * @link http://www.bonusthemes.com/goto/zonemanager
 */

defined('ZONEMANAGER') or die('Direct Access to this location is not allowed.');

$error = '';
$tpl_filename = trim(read_var('template', 'GET'));

if ($tpl_filename == '')
	$error = rcs('MISSING_GET_TEMPLATE');
else if (strpos($tpl_filename, '..') !== false || strpos($tpl_filename, '/') !== false || strpos($tpl_filename, '\\') !== false)
	$error = rcs('UNSAFE_GET_TEMPLATE');

if ($error == '') {
	require_once($dirname . '/includes/tpl_validation.php');
	$res = validate_template($base_tpl_dir, $tpl_filename, $manager_version, $min_tpl_version, $max_tpl_version, $tpl_error, $name, $tpl_url, $gstyles);
	if ($res != TPLVAL_SUCCESS)
		redirect($url_main . '?option=com_zonemgr');

	$tpl_dir = $base_tpl_dir . '/' . $tpl_filename;
	$conf_file = $tpl_dir . '/zl_config.php';
	$info_file = $tpl_dir . '/zl_info.php';

	require($info_file);

	$conf_file_size = filesize($conf_file);
	if ($conf_file_size == 0) {
		$vars = array();
	}
	else if ($fp = @fopen($conf_file, 'r')) {
		$contents = fread($fp, $conf_file_size);
		$vars = unserialize(substr($contents, strpos($contents, '?>') + 2));
		fclose($fp);
	}
	else {
		$error = rcs('ERROR_READING_CONFIG_FILE');
	}
}

if ($error != '') {
	require(sprintf($task_fmt, 'error'));
	return;
}

/**
 * Escapes strings to be used by JavaScript
 * 
 * @version 1.1.0.20070709
 * @author Alex Stylianos
 * @copyright Creative Pulse 2007
 * @link http://www.creativepulse.eu
 */
function json_esc($input, $esc_lt_gt = true)
{
	$result = '';
	$input = (string) $input;
	$conv = array( "'" => "'", '"' => '"', '&' => '&', '\\' => '\\', "\n" => 'n', "\r" => 'r', "\t" => 't', "\b" => 'b', "\f" => 'f' );

	if ($esc_lt_gt)
		$conv = array_merge($conv, array( '<' => 'u003C', '>' => 'u003E' ));

	for ($i = 0, $len = strlen($input); $i < $len; $i++)
		$result .= isset($conv[$input[$i]]) ? '\\' . $conv[$input[$i]] : $input[$i];

	return $result;
}

add_header('<script type="text/javascript" src="components/com_zonemgr/js/ZmMenu.js"></script>');
add_header('<script type="text/javascript" src="components/com_zonemgr/js/RegPosition.js"></script>');
add_header('<script type="text/javascript" src="components/com_zonemgr/js/Zone.js"></script>');
add_header('<script type="text/javascript" src="components/com_zonemgr/js/ZonePosition.js"></script>');
add_header('<script type="text/javascript" src="components/com_zonemgr/js/main.js"></script>');

$v_sv = get_antispoof_value();
$v_gapsz = isset($vars['gapsz']) ? $vars['gapsz'] : 10;
$v_total_width = isset($vars['total_width']) ? $vars['total_width'] : 960;
$v_live_url = get_live_url();
$v_name = htmlspecialchars($name);
$v_tpl_url = json_esc($tpl_url);

// summarize reserved positions

$reserved_positions = $tpl_config['reserved_positions'];

preg_match_all('/<div id="pos_([^"]+)" class="reg_position">/', $tpl_config['layout'], $m);
if (!empty($m[1]))
	$reserved_positions = array_merge($reserved_positions, $m[1]);

$reserved_positions = "'" . implode("', '", array_unique($reserved_positions)) . "'";

$gstyles_js = "'" . implode("', '", $gstyles) . "'";

$gstyles_samples = '';
$gstyles_li = '<ul id="gstyles_list">' . "\n";

$gstyle_live_prefix = get_live_url() . 'templates/' . $tpl_filename . '/images/zl_gstyles/';
$gstyle_file_prefix = $tpl_dir . '/images/zl_gstyles/';
foreach ($gstyles as $gstyle) {
	$gstyles_li .= '<li onmouseover="gstyle_mouseover(this, \'' . $gstyle . '\')" onmouseout="gstyle_mouseout(\'' . $gstyle . '\')">' . $gstyle . '</li>' . "\n";

	foreach (array('png', 'gif', 'jpg') as $ext)
		if (file_exists($gstyle_file_prefix . $gstyle . '.' . $ext)) {
			$gstyles_samples .= '<div id="gstyle_' . $gstyle . '"><img src="' . $gstyle_live_prefix . $gstyle . '.' . $ext . '" alt="" /></div>' . "\n";
			break;
		}
}

$gstyles_li .= '</ul>' . "\n";

$group_styles_js = '';
if (isset($vars['groups'])) {
	foreach ($vars['groups'] as $group => $style) {
		if ($group_styles_js != '')
			$group_styles_js .= ', ';
	
		$group_styles_js .= "'" . json_esc($group) . "': '" . json_esc($style) . "'";
	}
}

echo <<<EOF

<div id="zonemgr">

<table cellspacing="0" cellpadding="0" width="100%" id="buttons">
	<tr>
		<td><a href="http://www.bonusthemes.com/goto/zonemanager" target="_blank"><img src="components/com_zonemgr/images/logo_edit.png" alt="" border="0" /></a></td>
		<td nowrap="nowrap">
			<a href="$url_main?option=com_zonemgr">{$rcs('HD_TPL_LIST')}</a>
			<br/><a href="$v_tpl_url" target="_blank">$v_name</a>
		</td>
		<td nowrap="nowrap"> &nbsp; <img src="components/com_zonemgr/images/splitter.gif" alt="" /> &nbsp; </td>
		<td align="center" nowrap="nowrap">
			<button id="show_hide_btn" onclick="show_hide_staticareas()"></button>
			&nbsp; &nbsp;
			<button onclick="window.open('$url_aux?option=com_zonemgr&amp;no_html=1&amp;task=help', '', 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=780,height=550');">{$rcs('HELP')}</button>
		</td>
		<td nowrap="nowrap"> &nbsp; <img src="components/com_zonemgr/images/splitter.gif" alt="" /> &nbsp; </td>

EOF;

$set_gap = (boolean) @$tpl_config['set_gap'];
$set_total_width = (boolean) @$tpl_config['set_total_width'];

if ($set_gap || $set_total_width) {
	echo '		<td align="center" nowrap="nowrap">' . "\n";
	if ($set_gap)
		echo '			' . rcs('GAP_SIZE') . ' <button id="btn_gap" onclick="gap_btn_click()"></button>' . "\n";

	if ($set_gap && $set_total_width)
		echo '			&nbsp; &nbsp;' . "\n";

	if ($set_total_width)
		echo '			' . rcs('TOTAL_WIDTH') . ' <button id="btn_total_width" onclick="total_width_btn_click()"></button>' . "\n";

	echo '		</td>' . "\n";
	echo '		<td nowrap="nowrap"> &nbsp; <img src="components/com_zonemgr/images/splitter.gif" alt="" /> &nbsp; </td>' . "\n";
}

echo <<<EOF
		<td align="center" nowrap="nowrap">
			<button onclick="window.open('$v_live_url')">{$rcs('PREVIEW')}</button>
			&nbsp; &nbsp;
			<button onclick="window.location.reload()">{$rcs('RESET')}</button>
			&nbsp; &nbsp;
			<button onclick="save()" id="btn_save">{$rcs('APPLY_CHANGES')}</button>
		</td>
		<td><img src="components/com_zonemgr/images/splitter.gif" alt="" /></td>
	</tr>
</table>

EOF;

echo str_replace(
	'<ZONES>',
	'<div id="zones_host"></div>' . "\n" . '<div><button onclick="zone_append()">' . rcs('APPEND_ZONE') . '</button></div>' . "\n",
	$tpl_config['layout']
);

echo <<<EOF
<p>&nbsp;</p>
<table align="center"><tr><td>
<table cellspacing="0" cellpadding="0" align="center" class="adminlist">
	<thead>
	<tr id="aux_info">
		<th>{$rcs('AVAILABLE_GROUP_STYLES')}</th>
		<th>{$rcs('GROUPS_IN_USE')}</th>
		<th>{$rcs('WARNINGS')}</th>
	</tr>
	<thead>
	<tbody>
	<tr>
		<td valign="top">
			$gstyles_li
		</td>
		<td valign="top">
			<table>
				<tbody>
					<tr>
						<td align="center"><u>{$rcs('GROUP')}</u></td>
						<td align="center"><u>{$rcs('STYLE')}</u></td>
					</tr>
				</tbody>
				<tbody id="groups_host">
				</tbody>
			</table>
		</td>
		<td valign="top">
			<ul id="warnings_host">
			</ul>
		</td>
	</tr>
	</tbody>
</table>
</td></tr></table>

<div id="zm_menu">
	<div id="zm_menu_zone">
		<p><a href="javascript:void(0)" onclick="zone_add_before()">{$rcs('ADD_ZONE_ABOVE')}</a></p>
		<p><a href="javascript:void(0)" onclick="zone_add_after()">{$rcs('ADD_ZONE_BELOW')}</a></p>
		<hr/>
		<p><a href="javascript:void(0)" onclick="zone_move_up()">{$rcs('MOVE_ZONE_UP')}</a></p>
		<p><a href="javascript:void(0)" onclick="zone_move_down()">{$rcs('MOVE_ZONE_DOWN')}</a></p>
		<hr/>
		<p><a href="javascript:void(0)" onclick="zone_pos_add_start()">{$rcs('ADD_POS_START')}</a></p>
		<p><a href="javascript:void(0)" onclick="zone_pos_add_end()">{$rcs('ADD_POS_END')}</a></p>
		<hr/>
		<p><a href="javascript:void(0)" onclick="zone_pos_paste('start')">{$rcs('PASTE_POS_START')}</a></p>
		<p><a href="javascript:void(0)" onclick="zone_pos_paste('end')">{$rcs('PASTE_POS_END')}</a></p>
		<hr/>
		<p><a href="javascript:void(0)" onclick="zone_set('style')">{$rcs('SET_STYLE')}</a></p>
		<p><a href="javascript:void(0)" onclick="zone_set('group')">{$rcs('SET_GROUP')}</a></p>
		<hr/>
		<p><a href="javascript:void(0)" onclick="zone_delete()">{$rcs('DELETE')}</a></p>
	</div>
	<div id="zm_menu_main_body">
		<p><a href="javascript:void(0)" onclick="zone_pos_add_left()">{$rcs('ADD_POS_LEFT')}</a></p>
		<p><a href="javascript:void(0)" onclick="zone_pos_add_right()">{$rcs('ADD_POS_RIGHT')}</a></p>
		<hr/>
		<p><a href="javascript:void(0)" onclick="zone_pos_cut()">{$rcs('CUT')}</a></p>
		<p><a href="javascript:void(0)" onclick="zone_pos_paste('left')">{$rcs('PASTE_LEFT')}</a></p>
		<p><a href="javascript:void(0)" onclick="zone_pos_paste('right')">{$rcs('PASTE_RIGHT')}</a></p>
		<hr/>
		<p><a href="javascript:void(0)" onclick="zone_pos_set('width')">{$rcs('SET_WIDTH')}</a></p>
		<p><a href="javascript:void(0)" onclick="zone_pos_set('style')">{$rcs('SET_STYLE')}</a></p>
		<p><a href="javascript:void(0)" onclick="zone_pos_set('group')">{$rcs('SET_GROUP')}</a></p>
	</div>
	<div id="zm_menu_zone_position">
		<p><a href="javascript:void(0)" onclick="zone_pos_add_left()">{$rcs('ADD_POS_LEFT')}</a></p>
		<p><a href="javascript:void(0)" onclick="zone_pos_add_right()">{$rcs('ADD_POS_RIGHT')}</a></p>
		<hr/>
		<p><a href="javascript:void(0)" onclick="zone_pos_cut()">{$rcs('CUT')}</a></p>
		<p><a href="javascript:void(0)" onclick="zone_pos_paste('left')">{$rcs('PASTE_LEFT')}</a></p>
		<p><a href="javascript:void(0)" onclick="zone_pos_paste('right')">{$rcs('PASTE_RIGHT')}</a></p>
		<hr/>
		<p><a href="javascript:void(0)" onclick="zone_pos_set('width')">{$rcs('SET_WIDTH')}</a></p>
		<p><a href="javascript:void(0)" onclick="zone_pos_set('style')">{$rcs('SET_STYLE')}</a></p>
		<p><a href="javascript:void(0)" onclick="zone_pos_switch_collapsible()">{$rcs('SWITCH_COLLAPSIBLE')}</a></p>
		<p><a href="javascript:void(0)" onclick="zone_pos_set('group')">{$rcs('SET_GROUP')}</a></p>
		<hr/>
		<p><a href="javascript:void(0)" onclick="zone_pos_rename()">{$rcs('RENAME')}</a></p>
		<hr/>
		<p><a href="javascript:void(0)" onclick="zone_pos_delete()">{$rcs('DELETE')}</a></p>
	</div>
	<div id="zm_menu_reg_position">
		<p><a href="javascript:void(0)" onclick="reg_pos_set('width')">{$rcs('SET_WIDTH')}</a></p>
		<p><a href="javascript:void(0)" onclick="reg_pos_set('style')">{$rcs('SET_STYLE')}</a></p>
	</div>
</div>

</div>

<div id="gstyles_samples">
$gstyles_samples
</div>

<script type="text/javascript">
// <![CDATA[

$view_js_init

function zonemgr_page_load()
{

	document.zm_menu = new ZmMenu('zm_menu');

	document.sv = '$v_sv';
	document.gapsz = $v_gapsz;
	document.total_width = $v_total_width;
	document.cut_zone_idx = -1;
	document.cut_pos_name = '';
	document.tpl_filename = '$tpl_filename';
	document.reserved_positions = [$reserved_positions];
	document.gstyles = [$gstyles_js];
	document.groups = [];
	document.group_styles = {{$group_styles_js}};
	document.url_aux = '$url_aux';

	document.res = {
		btn_arrow: 'components/com_zonemgr/images/arrow_down.gif'
	}

	document.strs = {
		paste_self: '{$rcs('JS_PASTE_SELF')}',
		cut_missing: '{$rcs('JS_CUT_MISSING')}',
		cut_zone_missing: '{$rcs('JS_CUT_ZONE_MISSING')}',
		cut_pos_missing: '{$rcs('JS_CUT_POS_MISSING')}',
		zone_top_limit: '{$rcs('JS_ZONE_TOP_LIMIT')}',
		zone_bottom_limit: '{$rcs('JS_ZONE_BOTTOM_LIMIT')}',
		enter_total_width: '{$rcs('JS_ENTER_TOTAL_WIDTH')}',
		enter_gap: '{$rcs('JS_ENTER_GAP')}',
		staticareas_show: '{$rcs('JS_STATICAREAS_SHOW')}',
		staticareas_hide: '{$rcs('JS_STATICAREAS_HIDE')}',
		pos_rename: '{$rcs('JS_POS_RENAME')}',
		enter_width: '{$rcs('JS_ENTER_WIDTH')}',
		enter_style: '{$rcs('JS_ENTER_STYLE')}',
		enter_group: '{$rcs('JS_ENTER_GROUP')}',
		pos_name_exists: '{$rcs('JS_POS_NAME_EXISTS')}',
		invalid_pos_name: '{$rcs('JS_INVALID_POS_NAME')}',
		need_pos_name: '{$rcs('JS_NEED_POS_NAME')}',
		new_pos_name: '{$rcs('JS_NEW_POS_NAME')}',
		cannot_delete_zone_mainbody: '{$rcs('JS_NODEL_ZONE_MAINBODY')}',
		delete_pos: '{$rcs('JS_DEL_POS')}',
		delete_zone: '{$rcs('JS_DEL_ZONE')}',
		no_pos_selected: '{$rcs('JS_NO_POS_SEL')}',
		no_zone_selected: '{$rcs('JS_NO_ZONE_SEL')}',
		main_body: '{$rcs('JS_MAIN_BODY')}',
		invalid_int: '{$rcs('JS_INVALID_INT')}',
		zone: '{$rcs('JS_ZONE')}',
		width: '{$rcs('JS_WIDTH')}',
		style: '{$rcs('JS_STYLE')}',
		collapsible: '{$rcs('JS_COLLAPSIBLE')}',
		group: '{$rcs('JS_GROUP')}',
		yes: '{$rcs('JS_YES')}',
		no: '{$rcs('JS_NO')}',
		warn_unknown_styles_in_zones: '{$rcs('JS_WARN_UNKNOWN_STYLES_IN_ZONES')}',
		warn_unknown_styles_in_positions: '{$rcs('JS_WARN_UNKNOWN_STYLES_IN_POSITIONS')}',
		warn_unknown_styles_in_groups: '{$rcs('JS_WARN_UNKNOWN_STYLES_IN_GROUPS')}',
		warn_duplicate_groups: '{$rcs('JS_WARN_DUPLICATE_GROUPS')}',
		http_error: '{$rcs('JS_HTTP_ERROR')}',
		need_ajax: '{$rcs('JS_NEED_AJAX')}',
		saving: '{$rcs('JS_SAVING')}'
	};

	gap_update();
	total_width_update();

	document.reg_pos = new Array();
	var divs = document.getElementsByTagName('div');
	for (var i = 0, len = divs.length; i < len; i++)
		if (divs[i].className == 'reg_position')
			document.reg_pos.push(new RegPosition(divs[i].id.substring(4, divs[i].id.length)));

	document.zones = {
		count: 0,
		reg: {}
	}

EOF;

if (isset($vars['regpos'])) {
	foreach ($vars['regpos'] as $pos_name => $pos_info)
		foreach ($pos_info as $prop => $value)
			if ($value != '')
				echo "	reg_pos_init('$pos_name', '$prop', '$value');\n";

	echo "\n";
}

if (!isset($vars['zones'])) {
	echo "	document.zones.reg['zone_0'] = new Zone(0, null);\n";
	echo "	document.zones.reg['zone_0'].add_main_body();\n";
	echo "	document.zones.count = 1;\n";
}
else {
	foreach ($vars['zones'] as $i_zone => $zone) {
		echo "	document.zones.reg['zone_{$i_zone}'] = new Zone({$i_zone}, null);\n";

		$update = false;

		if (@$zone['style'] != '') {
			$update = true;
			echo "	document.zones.reg['zone_{$i_zone}'].style = '{$zone['style']}';\n";
		}

		if (@$zone['group'] != '') {
			$update = true;
			echo "	document.zones.reg['zone_{$i_zone}'].group = '{$zone['group']}';\n";
		}

		if ($update)
			echo "	document.zones.reg['zone_{$i_zone}'].setup_details();\n\n";

		if (isset($zone['pos'])) {
			foreach ($zone['pos'] as $i_pos => $pos) {
				if ($pos['name'] == '')
					echo "	var pos = document.zones.reg['zone_{$i_zone}'].add_main_body();\n";
				else
					echo "	var pos = document.zones.reg['zone_{$i_zone}'].add_position_end('{$pos['name']}');\n";
	
				$update = false;
	
				if (@$pos['width'] != '') {
					$update = true;
					echo "	pos.width = '{$pos['width']}';\n";
				}
	
				if (@$pos['style'] != '') {
					$update = true;
					echo "	pos.style = '{$pos['style']}';\n";
				}
	
				if (@$pos['collapsible'] != '') {
					$update = true;
					echo "	pos.collapsible = '{$pos['collapsible']}';\n";
				}
	
				if (@$pos['group'] != '') {
					$update = true;
					echo "	pos.group = '{$pos['group']}';\n";
				}
	
				if ($update)
					echo "	pos.setup_details();\n\n";
			}
		}
	}
	echo "	document.zones.count = " . count($vars['zones']) . ";\n\n";
}

echo <<<EOF

	show_hide_staticareas();
	review_settings();
}

if (window.addEventListener)
	window.addEventListener('load', zonemgr_page_load, false);
else if (window.attachEvent)
	window.attachEvent('onload', zonemgr_page_load);

// ]]>
</script>

EOF;

require($dirname . '/includes/footer.php');

?>