<?php

/**
 * Zone Manager
 *
 * @package zonemanager
 * @version 2.0
 * @author Bonus Themes
 * @copyright Bonus Themes 2008
 * @license GNU/GPL
 * @link http://www.bonusthemes.com/goto/zonemanager
 */

defined('ZONEMANAGER') or die('Direct Access to this location is not allowed.');

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

<head>

<title>Zone Manager v2.0 Help</title>

<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />

<style type="text/css">
* {
	font-family: Verdana, Arial, Helvetica, sans-serif;
	font-size: 11px;
}
h1 {
	font-size: 18px;
}
h2 {
	font-size: 16px;
	font-weight: bold;
	color: #5e8ef1;
	border-bottom: 1px solid #ddd;
	margin: 35px 0px 0px 0px;
	padding-bottom: 3px;
}
h3 {
	font-size: 13px;
	font-weight: bold;
	color: #007;
	border-bottom: 1px solid #ddd;
	margin: 25px 0px 0px 0px;
	padding-bottom: 0px;
}
button {
	cursor: pointer;
}
em {
	background-color: #f8f8f8;
}
dt {
	font-size: 11px;
	font-weight: bold;
	margin: 15px 0px 0px 0px;
	padding-bottom: 0px;
}
#credits {
	text-align: center;
	margin: 70px 0px 30px 0px;
}
</style>

</head>

<body>

<div style="float:right">
	<button onclick="window.print()">Print</button>
	<button onclick="window.close()">Close</button>
</div>

<h1>Zone Manager v2.0 Help</h1>

&nbsp;
<p><strong>Contents</strong></p>
<ul>
	<li><a href="#introduction">Introduction</a></li>
	<li><a href="#dictionary">Zone Layout Dictionary</a></li>
	<li><a href="#list">Template List</a></li>
	<li><a href="#editor">Zone Editor</a></li>
	<li><a href="#styles">Styles</a></li>
	<li><a href="#howto">How to</a></li>
	<li><a href="#support">Additional support</a></li>
</ul>


<a name="introduction"></a>
<h2>Introduction</h2>

<p>The Zone Layout technology allows you to create custom module positions organized in zones. In order to accomplish that, you have to use the Joomla! component <em>Zone Manager</em>, and a Joomla! template that is compatible to the Zone Layout technology.</p>

<p>With the Zone Manager you can manage zones, and positions in those zones. Once you create new positions you can go to the regular Joomla! module manager and assign them modules. On the front end, the template takes over and controls style of the zones, positions and modules.</p>

<p>There are plenty of tricks to help you create a nice look on your website. Apart from the <em>module styles</em>, better known as <em>module suffixes</em> in the Joomla! universe, you also have <em>group styles</em>. With the Zone Manager you can give a position a group style. You can also group positions and assign a style for that group. And of course, you can group zones and assign it a style.</p>

<p>For tutorials, support forums and more help, visit <a href="http://www.bonusthemes.com">http://www.bonusthemes.com</a> .</p>


<a name="dictionary"></a>
<h2>Zone Layout Dictionary</h2>

<dl>
	<dt>Group</dt>
	<dd>There are two kinds of groups: position groups and zone groups. The essence of groups is to assign them a group style so that the grouped elements appear to be joined.</dd>

	<dt>Group Style</dt>
	<dd>Group styles (or gstyles) make groups of positions or groups of zones appear in a joined area.</dd>

	<dt>Main body</dt>
	<dd>Special type of control that displays the main body content of the web page.</dd>

	<dt>Module</dt>
	<dd>A custom script that presents data in a box-shaped area. Examples: Login module, Search module, Online users module. Modules appear as parts of Positions.</dd>

	<dt>Module Style</dt>
	<dd>Module styles (or mstyles) is a better name we chose to refer to Module Suffixes.</dd>

	<dt>Module Suffix</dt>
	<dd>A style for a module. The name follows the internal method used for the style to be displayed: a suffix that triggers pre-arranged CSS classes.</dd>

	<dt>Position</dt>
	<dd>An area that contains modules. In the Zone Manager there are regular positions and dynamic ones. The dynamic positions are the ones you create inside the zones.</dd>

	<dt>Template</dt>
	<dd>Templates are display mechanisms for content. They are responsible to get content from the database, organize it in main body, modules, positions and zones and present it in an aethetically beautiful environment.</dd>

	<dt>Zone</dt>
	<dd>A zone is a horizontal area that contains positions or the main body.</dd>

</dl>


<a name="list"></a>
<h2>Template List</h2>

<p>The first thing to see when opening the Zone Manager component is a list of the site templates. Next to each template there is a status message.</p>

<p>Templates that are compatible to the Zone Layout technology have the form of a link and their status appears in a green color. Click on the template name to get into the zone editor.</p>

<p>Templates that are still compatible but they have an error that makes the Zone Manager non functional have a status message in a red color. The status messages are clickable, and if you click on them you will see a more detailed explanation of the problem. The most usual problems are permission related on certain files in the template directory. More specifically, the web server needs to have write permissions on the files <em>zl_config.php</em> and <em>templateDetails.xml</em>. Whatever the problem is, click on the status message to read a more detailed explanation.</p>

<p>On the bottom of the list there are the templates that are not compatible to the Zone Layout technology and their status appears in a gray color.</p>


<a name="editor"></a>
<h2>Zone Editor</h2>

<p>When you select a template from the list you get into the Zone Editor. On the top of the screen you can see control buttons, on the main area you can edit the zones and on the bottom there are supplementary information and services.</p>

<p>One important thing to remember about the editor is that whatever changes you do, you will have to click the <em>Apply changes</em> button to save them.</p>


<h3>Controls on the top area</h3>

<dl>
	<dt>Template List &amp; Template name</dt>
	<dd>These are two different links. Click on the Template List link to go back to the list of templates. Click on the template name to go to the template's author website.</dd>

	<dt>Show static areas / Hide static areas</dt>
	<dd>Click this button to show or hide the areas with the static regular positions. By hiding the static areas you have more space to edit the zones.</dd>

	<dt>Help</dt>
	<dd>Shows an online help window.</dd>

	<dt>Gap size</dt>
	<dd>Use this button to control the size of the gap between positions and zones. The gap must be an integer number that represents pixels.</dd>

	<dt>Total width</dt>
	<dd>Use this button to control the total width of the website. The width must be an integer number that represents pixels.</dd>

	<dt>Preview</dt>
	<dd>Click the Preview button to open a new window that shows the front of the website. Remember that you need to <u>click the Apply changes button before you preview the website</u>.</dd>

	<dt>Reset</dt>
	<dd>Click the Reset button to reload the page. This will cancel any changes you might have done.</dd>

	<dt>Apply changes</dt>
	<dd>Click the Apply changes button to save your changes.</dd>

</dl>


<h3>Zones and regular positions area</h3>

<p>In the main part of the screen you can find controls that help you manage zones and regular positions. Every element in this area has a button you can use to open a drop-down menu with related actions.</p>

<p>The basic idea is to create zones and add positions in them. Once the new positions are added you can use the regular Joomla! module manager to assign them modules. From the Zone Manager you can also group positions, or zones and give them styles so that they appear to be joined. You can make combinations with styles on single positions or zones, and styles in groups of positions or styles in groups of zones.</p>

<p>There are plenty of ways to control positions and zones. Go ahead and click on the drop-down menus to explore the available options. You can move zones up or down, cut and paste positions and more.</p>

<p>The following sections contain more details about groups and styles.</p>


<h3>Controls on the bottom area</h3>

<dl>
	<dt>Available group styles</dt>
	<dd>This is a list of the available styles you can use for your groups and positions.</dd>

	<dt>Groups in use</dt>
	<dd>This is a dynamic list that displays the groups you created for your zones and positions. Next to each group you have a text box that allows you to set a style for the group. When you assign a style that is not supported the text box becomes red.</dd>

	<dt>Warnings</dt>
	<dd>This is a list of warnings generated while you edit the zones.</dd>

</dl>


<a name="styles"></a>
<h2>Styles</h2>

<p>In the Zone Layout technology there are two distinct kinds of styles. There are styles that decorate modules which are better known in the Joomla! universe as module suffixes. We call them module styles or just <em>mstyles</em>. Then, there are styles for groups. We call them group styles or simply <em>gstyles</em>.</p>

<p>With the Zone Manager you can assign group styles (gstyles) to your groups, or to single zones and positions. Module styles are assigned by the regular Joomla! module manager by setting the module suffix.</p>

<p>Each template has its own gstyles and the Zone Manager has an internal mechanism to understand that. Whenever you try to assign a group style that is not supported by the template, the Zone Manager paints it red and it generates a warning message on the bottom right corner.</p>



<a name="howto"></a>
<h2>How to</h2>

<h3>How to create a zone</h3>
<p>To create a zone click the <em>Append Zone</em> button on the bottom of the screen. Another way to create a zone is to open the drop-down menu of an existing zone and use the available options to create a new zone above or below it.</p>

<h3>How to create a position in a zone</h3>
<p>To create a position in a zone, open the drop-down menu of a zone and use the available options to create a new position on the start or the end of the zone. Another way to create a position is to open the drop-down menu of an existing position and use the available options to create a new position on its left or its right side.</p>

<h3>How to create zone groups</h3>
<p>Open the drop-down menu of a zone and set a group name. Then open the drop-down menu of another zone and set the same group name. Repeat the same for other zones you want to add in the group. When done, go to the bottom of the page and set a style for that group. Attention: Make sure that the zones in the group are all next to each other and that you have not used the same group name for positions.</p>

<h3>How to create position groups</h3>
<p>Open the drop-down menu of a position and set a group name. Then open the drop-down menu of another position and set the same group name. Repeat the same for other positions you want to add in the group. When done, go to the bottom of the page and set a style for that group. Attention: Make sure that the positions in the group are all next to each other and that you have not used the same group name for zones.</p>



<a name="support"></a>
<h2>Additional support</h2>

<p>For additional support visit <a href="http://www.bonusthemes.com">http://www.bonusthemes.com</a> .</p>


<p id="credits">Zone Manager is a GNU/GPLv2 software created by <a href="http://www.creativepulse.eu" target="_blank">Creative Pulse</a> and <a href="http://www.mediagrafix.gr" target="_blank">Mediagrafix</a> for <a href="http://www.bonusthemes.com" target="_blank">Bonus Themes</a>.
<br/>(C)2008 Bonus Themes. All rights reserved.</p>

</body>

</html>
